/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 */
#ifndef DOT1QTPFDBTABLE_H
#define DOT1QTPFDBTABLE_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup misc misc: Miscellaneous routines
 *
 * @{
 */
#include <net-snmp/library/asn1.h>

/* other required module components */
    /* *INDENT-OFF*  */
config_add_mib(Q-BRIDGE-MIB)
config_require(Q-BRIDGE-MIB/dot1qTpFdbTable/dot1qTpFdbTable_interface)
config_require(Q-BRIDGE-MIB/dot1qTpFdbTable/dot1qTpFdbTable_data_access)
config_require(Q-BRIDGE-MIB/dot1qTpFdbTable/dot1qTpFdbTable_data_get)
config_require(Q-BRIDGE-MIB/dot1qTpFdbTable/dot1qTpFdbTable_data_set)
    /* *INDENT-ON*  */

/* OID and column number definitions for dot1qTpFdbTable */
#include "dot1qTpFdbTable_oids.h"

/* enum definions */
#include "dot1qTpFdbTable_enums.h"

/* *********************************************************************
 * function declarations
 */
void init_dot1qTpFdbTable(void);
void shutdown_dot1qTpFdbTable(void);

/* *********************************************************************
 * Table declarations
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table dot1qTpFdbTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * Q-BRIDGE-MIB::dot1qTpFdbTable is subid 2 of dot1qTp.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.17.7.1.2.2, length: 11
*/
/* *********************************************************************
 * When you register your mib, you get to provide a generic
 * pointer that will be passed back to you for most of the
 * functions calls.
 *
 * TODO:100:r: Review all context structures
 */
    /*
     * TODO:101:o: |-> Review dot1qTpFdbTable registration context.
     */
typedef netsnmp_data_list dot1qTpFdbTable_registration;

/**********************************************************************/
/*
 * TODO:110:r: |-> Review dot1qTpFdbTable data context structure.
 * This structure is used to represent the data for dot1qTpFdbTable.
 */
/*
 * This structure contains storage for all the columns defined in the
 * dot1qTpFdbTable.
 */
typedef struct dot1qTpFdbTable_data_s {
    
        /*
         * dot1qTpFdbPort(2)/INTEGER32/ASN_INTEGER/long(long)//l/A/w/e/R/d/h
         */
   long   dot1qTpFdbPort;
    
        /*
         * dot1qTpFdbStatus(3)/INTEGER/ASN_INTEGER/long(u_long)//l/A/w/E/r/d/h
         */
   u_long   dot1qTpFdbStatus;
    
} dot1qTpFdbTable_data;


/*
 * TODO:120:r: |-> Review dot1qTpFdbTable mib index.
 * This structure is used to represent the index for dot1qTpFdbTable.
 */
typedef struct dot1qTpFdbTable_mib_index_s {

        /*
         * dot1qFdbId(1)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h
         */
   u_long   dot1qFdbId;

        /*
         * dot1qTpFdbAddress(1)/MacAddress/ASN_OCTET_STR/char(char)//L/a/w/e/R/d/H
         */
   char   dot1qTpFdbAddress[6];
   size_t      dot1qTpFdbAddress_len;


} dot1qTpFdbTable_mib_index;

    /*
     * TODO:121:r: |   |-> Review dot1qTpFdbTable max index length.
     * If you KNOW that your indexes will never exceed a certain
     * length, update this macro to that length.
     *
     * BE VERY CAREFUL TO TAKE INTO ACCOUNT THE MAXIMUM
     * POSSIBLE LENGHT FOR EVERY VARIABLE LENGTH INDEX!
     * Guessing 128 - col/entry(2)  - oid len(11)
*/
#define MAX_dot1qTpFdbTable_IDX_LEN     7


/* *********************************************************************
 * TODO:130:o: |-> Review dot1qTpFdbTable Row request (rowreq) context.
 * When your functions are called, you will be passed a
 * dot1qTpFdbTable_rowreq_ctx pointer.
 */
typedef struct dot1qTpFdbTable_rowreq_ctx_s {

    /** this must be first for container compare to work */
    netsnmp_index        oid_idx;
    oid                  oid_tmp[MAX_dot1qTpFdbTable_IDX_LEN];
    
    dot1qTpFdbTable_mib_index        tbl_idx;
    
    dot1qTpFdbTable_data              data;

    /*
     * flags per row. Currently, the first (lower) 8 bits are reserved
     * for the user. See mfd.h for other flags.
     */
    u_int                       rowreq_flags;

    /*
     * TODO:131:o: |   |-> Add useful data to dot1qTpFdbTable rowreq context.
     */
    
    /*
     * storage for future expansion
     */
    netsnmp_data_list             *dot1qTpFdbTable_data_list;

} dot1qTpFdbTable_rowreq_ctx;

typedef struct dot1qTpFdbTable_ref_rowreq_ctx_s {
    dot1qTpFdbTable_rowreq_ctx *rowreq_ctx;
} dot1qTpFdbTable_ref_rowreq_ctx;

/* *********************************************************************
 * function prototypes
 */
    int dot1qTpFdbTable_pre_request(dot1qTpFdbTable_registration * user_context);
    int dot1qTpFdbTable_post_request(dot1qTpFdbTable_registration * user_context,
        int rc);

    int dot1qTpFdbTable_rowreq_ctx_init(dot1qTpFdbTable_rowreq_ctx *rowreq_ctx,
                                   void *user_init_ctx);
    void dot1qTpFdbTable_rowreq_ctx_cleanup(dot1qTpFdbTable_rowreq_ctx *rowreq_ctx);


    dot1qTpFdbTable_rowreq_ctx *
                  dot1qTpFdbTable_row_find_by_mib_index(dot1qTpFdbTable_mib_index *mib_idx);

extern const oid dot1qTpFdbTable_oid[];
extern const int dot1qTpFdbTable_oid_size;


#include "dot1qTpFdbTable_interface.h"
#include "dot1qTpFdbTable_data_access.h"
#include "dot1qTpFdbTable_data_get.h"
#include "dot1qTpFdbTable_data_set.h"

/*
 * DUMMY markers, ignore
 *
 * TODO:099:x: *************************************************************
 * TODO:199:x: *************************************************************
 * TODO:299:x: *************************************************************
 * TODO:399:x: *************************************************************
 * TODO:499:x: *************************************************************
 */

#ifdef __cplusplus
}
#endif

#endif /* DOT1QTPFDBTABLE_H */
/** @} */
